
void standby(void){  //~

   motor_speed(0);

   putc(GLCD_CLEAR); delay_ms(GLCD_CLEAR_DELAY);  // clear screen
   printf("  ROBOMAGELLAN");

   if(get_battery_voltage() < 11){
      putc('r'-CTRL);  // red
      printf("\r\r  LOW BATTERY\r");
      putc('b'-CTRL);  // blue
      delay_ms(1000);
   }

   while(state==_STANDBY){
      handle_user_input();
   }

   // before leaving this function, display target waypoint
      putc('t'-CTRL);  // magenta
      printf("\r%1u",route[current_leg]); // print target waypoint
      putc('b'-CTRL);  // blue


}

//-----------------------------------------------------------------------

void beginning(void){   //~

   int16 current_heading;
   signed int16 x, y;
   int8 dir, n;
   int8 cur_dir;
   int8 delta;
   int32 time_to_tx_info;

   // 1 calculate heading based on stored waypoints
   // 2 determine which way to turn
   // 3 steer in the right direction and go
   // 4 inform humans

   // MAIN LOOP

   // wait until robot is facing destination
   // determine the right direction again, break when the robot overshoots



   // steer in the right direction and go

   // INITIAL INSTRUCTIONS
   //-----------------------
   putc('B');
   tone(440, 200);

      if (look_ahead() < TURN_START){
         state = _OBSTACLE;
         delay_ms(500);   
         return;
      }



   //  calculate heading and distance from current position to selected waypoint
#if(TRUE)
   target_waypoint = route[current_leg];
   printf(lcd_putc, "waiting for GPS....");
   while(1){
      n = get_gpsstring();
      if(n == ERROR){
         printf("\rno GPS signal");
         delay_ms(3000);
         state=_STANDBY;
         return;
      }
      if(gpsstring_to_minutes() == SUCCESS) break;  // results put in current_lat & current_lon
   }
   x = (signed int16)((lon[target_waypoint] - current_lon) * X_FACTOR);
   y = (signed int16)((lat[target_waypoint] - current_lat) * Y_FACTOR);
   desired_heading = xy_to_heading(x,y);
   distance_remaining_since_gps_check = xy_to_distance(x,y);
   wheel_ticks_since_gps_check = 0;

#endif

   // determine which way to turn
   current_heading = compass();
   if (desired_heading > current_heading){
      if ( desired_heading - current_heading < 180) dir = 'R';
      else dir = 'L';
   }
   else {
      if ( current_heading - desired_heading < 180) dir = 'L';
      else dir = 'R';
   }

   // inform humans
   LCD_CLEAR
   printf(lcd_putc, "leg: %u", current_leg);
   printf(lcd_putc, "   TURNING\n");

   // steer in the right direction and go
   delta = ABS(desired_heading - current_heading);
   if ((dir=='L') && (delta >5)) steer(STEER_HARD_LEFT);
   if ((dir=='L') && (delta <=5)) steer(STEER_SLIGHT_LEFT);
   if ((dir=='R') && (delta >5)) steer(STEER_HARD_RIGHT);
   if ((dir=='R') && (delta <=5)) steer(STEER_SLIGHT_RIGHT);

 /* report */
 //     putc(GLCD_CLEAR);    //clear screen
 //     delay_ms(GLCD_CLEAR_DELAY);

// wait for human
//      printf("OK? "); // removed oct. 10, 2008
  //    getc(); // removed oct. 10, 2008

// start turning
    motor_speed(60);


   // MAIN LOOP FOR BEGINNING
   // wait until robot is facing destination

   while(TRUE){

      // take a compass reading
      current_heading = compass();

      // determine the right direction again to see if the robot overshoots
      if (desired_heading > current_heading){
         if ( desired_heading - current_heading < 180) cur_dir = 'R';
         else cur_dir = 'L';
      }
      else {
         if ( current_heading - desired_heading < 180) cur_dir = 'L';
         else cur_dir = 'R';
      }

      // end the turn when as soon as robot overshoots the right direction
      if(cur_dir != dir) break;

    }  // end of main loop

   steer (STEER_STRAIGHT);
   state = _MIDDLE;
   return;

}   //end of beginning

//-----------------------------------------------------------------------

void middle(void){ //~

   int16 current_heading;
   int32 time_to_adjust_steering;
   int32 time_to_gps_check;
   int32 time_to_tx_info;
   int32 time_to_display_info;
   int8 dir, value8;
   int16 delta;
   int16 n;
 //  int16 distance_remaining;

   signed int16 x, y;

   // Initialization for MIDDLE state --------------------

   putc('M');
   steer (STEER_STRAIGHT);
   motor_speed(100);

   time_to_adjust_steering = current_time + 500;
   time_to_gps_check = current_time + GPS_UPDATE_INTERVAL;
   time_to_tx_info = current_time + 1000;


   // - - - Main loop for the MIDDLE state - - -
   //
   // Navigating
   // 1 - update heading using compass (every half second)
   // 2 - update heading using GPS     (every 10 seconds)
   // 3 - check if almost there        ()
   // 4 - need to avoid object?        (sonar<200)
   // 5 - update distance remaining    (no longer used)
   //
   // Communicating with humans
   // 6 -
   // 7 - update handheld device       (every 2 seconds)
   // 8 - check for command from humans
   //
   // Sanity checks
   // x - check if the wheel is moving (not implemented yet)
   // x - check if getting closer      (not implemented yet)

   while(TRUE){

// 1  Compass-based steering adjustment (every half sec)

      if(current_time >= time_to_adjust_steering){

          // determine which way to turn
         current_heading = compass();
         if (desired_heading > current_heading){
            if ( desired_heading - current_heading < 180) dir = 'R';
            else dir = 'L';
         }
         else {
            if ( current_heading - desired_heading < 180) dir = 'L';
            else dir = 'R';
         }

         delta = ABS(desired_heading - current_heading);
         omi(OMI_OFF);
         if (delta < 3) {
            steer(STEER_STRAIGHT);
            omi(OMI_AHEAD);
//            putc('.');  // added sept25-2008
         }
         else if (dir=='L') {
            steer(STEER_SLIGHT_LEFT);
//            steer(STEER_STRAIGHT + (delta*6));  // added oct. 10, 2008
            omi(OMI_LEFT);
//            putc('<');  // added sept25-2008

         }
         else if (dir=='R') {
            steer(STEER_SLIGHT_RIGHT);
//            steer(STEER_STRAIGHT - (delta*6)); // added oct. 10, 2008
            omi(OMI_RIGHT);
//            putc('>');  // added sept25-2008

         }

         // BUG FOUND. the following line was in with "steer(STEER_SLIGHT_RIGHT)"
         time_to_adjust_steering = current_time + 500;
      }

//debug
#if(TRUE)
// 2 Update heading using GPS
      if(current_time >= time_to_gps_check){
         target_waypoint = route[current_leg];
         while(1){
            n = get_gpsstring();
            if(n == ERROR){
               printf("\rlost GPS signal");
               motor_speed(0);
               delay_ms(3000);
               state=_STANDBY;
               return;
            }
            if(gpsstring_to_minutes() == SUCCESS) break;
         }
         x = (signed int16)((lon[target_waypoint] - current_lon) * X_FACTOR);
         y = (signed int16)((lat[target_waypoint] - current_lat) * Y_FACTOR);
         desired_heading = xy_to_heading(x,y);
         distance_remaining_since_gps_check = xy_to_distance(x,y);
         wheel_ticks_since_gps_check = 0;
         time_to_gps_check = current_time + GPS_UPDATE_INTERVAL;  //set next time
         putc('r'-CTRL);  // red
         putc('G');
         putc('b'-CTRL);  // blue
         // FUTURE IMPROVEMENT: check if the update is sensible



      }
#endif


// 3 Check if close enough to target
      if((distance_remaining_since_gps_check - (wheel_ticks_since_gps_check / TICKS_PER_METER)) <= CLOSE_TO_DESTINATION){
//      if(distance_remaining_since_gps_check  <= 3){

          state = _ENDING;
          return;
      }


// 4 avoid obsticle?
      if (look_ahead() < TURN_START){
         state = _OBSTACLE;
        delay_ms(25);   //delay introduced to slow down sampling rate and diminish false return
        return;
      }

// 5  update distance remaining
//       distance_remaining = distance_remaining_since_gps_check - (wheel_ticks_since_gps_check / TICKS_PER_METER);


// 7  send info to terminal every second
       if(current_time >= time_to_tx_info){
         printf("%1Lu", (distance_remaining_since_gps_check - (wheel_ticks_since_gps_check / TICKS_PER_METER))/10);
           time_to_tx_info = current_time + 1000;
       }

// 8  check message from boss
      if(OERR){
        for(n=1; n<=5; n++){
           output_low(STATUS_LED);
           delay_ms(50);
           output_high(STATUS_LED);
           delay_ms(50);
        }
        CREN=0;
        CREN=1;
      }

      if(kbhit()){
         value8 = getc();
         if (value8 == 'z'){
            state = _STANDBY;
            return;
         }
      }

  }  // end of main loop

}   //end of middle

//-----------------------------------------------------------------------

void ending(void){

   int8 n;
   int32 time_to_tx_info;

   putc('E');


   // slow down
   motor_speed(50);
   delay_ms(1000);  // changed sept 30, 2008

   // stop
   motor_speed(0);

   printf("\rleg completed");

   // 3 beeps
   for (n=1; n<=3;n++){
      tone(1000, 500);
      delay_ms(500);
   }

   // wait a bit
   delay_ms(3000);

   // move on to the next waypoint if there is one
   if(((route[current_leg+1]) != 0) && (current_leg < ROUTE_MAX) ){
      current_leg++;
      putc('t'-CTRL);  // magenta
      printf("\r%1u",route[current_leg]); // print target waypoint
      putc('b'-CTRL);  // blue

      state = _BEGINNING;
      return;
   }

   // end of competition
   putc('g'-CTRL);  // green
   printf("\r\rcourse completed"); // added oct. 2, 2008
   putc('b'-CTRL);  // blue
   delay_ms(5000);
   getc();
   state = _STANDBY;

}   //end of ending

//-----------------------------------------------------------------------

void obstacle(void){

   int8 n8, count;
   int16 n16;
   int16 left, right, distance;
   int32 timeout;
   
   // STOP
   motor_speed(0);

   putc('X');

  // DECIDE WHICH WAY TO TURN
   five_point_scan();
   delay_ms(500); // added oct. 3, 2008

   left=zone[1];
   if (zone[2] < zone[1]) left = zone[2];

   right=zone[5];
   if (zone[5] < zone[4]) right = zone[4];

   if (left < right) steer(STEER_HARD_RIGHT);
   else steer(STEER_HARD_LEFT);

   motor_speed(50);
   timeout = current_time + 5000;


   // STEP 1 - KEEP TURNING UNTIL >3m AHEAD
   while(1){
      distance = look_left();
      if(distance<100){
         state = _QUIT;
         return;
      }

      distance = look_ahead();
      if(distance<100){
         state = _QUIT;
         return;
      }   
      if(distance>300){
         break;
      }

      distance = look_right();
      if(distance<100){
         state = _QUIT;
         return;
      }

      if(current_time >= timeout){printf("\rTIMEOUT"); }


   }


   // Step 2 - GO AHEAD UNTIL >3M AHEAD AND BOTH SIDES

   steer(STEER_STRAIGHT);

   // if r l or a are < 1m, quit and report

   while(1){

      count = 0;
   
      distance = look_left();
      if(distance>300) count++;
      if(distance<100){
         printf("\r%3um on left");
         state = _QUIT;
         return;
      }

      distance = look_ahead();
      if(distance>300) count++;
      if(distance<100){
         printf("\r%3um in front");
         state = _QUIT;
         return;
      }
   
      distance = look_right();
      if(distance>300) count++;
      if(distance<100){
         printf("\r%3um on right");
         state = _QUIT;
         return;
      }
 
      if(count >= 3){
         state = _BEGINNING;
         return;
      }

      if(current_time >= timeout){printf("\r  timeout"); }

      if(input(LEFT_BUMPER_PIN) || input(LEFT_BUMPER_PIN )){
         printf("\rbumper");
         state = _QUIT;
         return;
      }

      // check for manual control request
      if(OERR){
         for(n8=1; n8<=5; n8++){
            output_low(STATUS_LED);
            delay_ms(50);
            output_high(STATUS_LED);
            delay_ms(50);
         }
         CREN=0;
         CREN=1;
      } 
      if(kbhit()){
         n8 = getc();
         if (n8 == 'z'){
            state = _STANDBY;
            return;
         }
      }

   } // end of step 2


}     //end of obstacle

//=======================================================================

void quit(void){

   motor_speed(0);
   printf("\r I GIVE UP");
   getc();
   state=_STANDBY;
   return;
}




